package com.liang.dao;

import com.liang.entity.StaDirector;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * 负责人(StaDirector)表数据库访问层
 *
 * @author makejava
 * @since 2023-04-09 21:54:44
 */
public interface StaDirectorDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    StaDirector queryById(Integer id);

    /**
     * 通过主表ID查询数据
     *
     * @param zb 主表
     * @return 实例对象
     */
    List<StaDirector> queryByZbId(Integer zb);

    /**
     * 查询指定行数据
     *
     * @param staDirector 查询条件
     * @param pageable    分页对象
     * @return 对象列表
     */
    List<StaDirector> queryAllByLimit(StaDirector staDirector, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param staDirector 查询条件
     * @return 总行数
     */
    long count(StaDirector staDirector);

    /**
     * 新增数据
     *
     * @param staDirector 实例对象
     * @return 影响行数
     */
    int insert(StaDirector staDirector);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaDirector> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<StaDirector> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaDirector> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<StaDirector> entities);

    /**
     * 修改数据
     *
     * @param staDirector 实例对象
     * @return 影响行数
     */
    int update(StaDirector staDirector);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    int batchDelete(List<Integer> idList, Integer zb);

    /**
     * 根据主表id删除记录
     *
     * @param zbId
     * @return
     */
    int deleteByZbId(Integer zbId);
}

